MODULE L_Feeder_Teach

    
    !--Greifposition Kalibrierteil
    PERS robtarget pL_GP_KT:=[[0,0,10],[9.59358E-05,0.710705,-0.70349,3.41438E-05],[-1,-1,-1,4],[132.259,9E+09,9E+09,9E+09,9E+09,9E+09]];
    
    
    !***************************************************************************
    !*  Procedure  rL_InitBeforeHome
    !*
    !*
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_InitBeforeHome()
        
        r_Calibrate_GR;
        
        r_tKalibrier_GR_AUF;

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_InitAfterHome
    !*
    !*
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_InitAfterHome()

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_GP_KT
    !*
    !*  In Greifposition Kalibrierteil fahren und Kalibrierteil greifen
    !*  50 mm oberhalb Greifposition Kalibrierteil halten
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_GP_KT()
        
        SingArea\Wrist;
        
        ConfL\On;
        
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Greifposition Kalibrierteil (fine Zone verwenden)
        MoveJ pL_GP_KT,vSlow,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibriergreifer schliessen
        r_tKalibrier_GR_ZU;
        !
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_AP_N()
    !*
    !*  Kalibrierteil in Ablageposition Nest ablegen
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_AP_N()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50 mm vertikal ber Ablageposition Nest 1
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        WaitTime 1;
        !
        !--Greifposition (fine Zone verwenden)
        MoveL pL_GP_KT,vPos,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibriergreifer ffnen
        r_tKalibrier_GR_AUF;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_HomePos_ohne_Teil_aus_N()
    !*
    !*  YuMi fhrt aus Ablageposition in Home Position
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_HomePos_ohne_Teil_aus_N()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveL Offs(pL_GP_KT,0,0,50),vfast,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        WaitTime 1;
        !
        !--in Home Position fahren
        MoveJ pL_HomePos,vfast,fine,tKalibrier_GR;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_AP_N_90()
    !*
    !*  YuMi fhrt in Ablageposition Nest, greift das Kalibrierteil,
    !*  dreht es um 90 und macht den Greifer auf
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_AP_N_90()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveL pL_GP_KT,vSlow,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibriergreifer schliessen
        r_tKalibrier_GR_ZU;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveL Offs(pL_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibrierteil um 90 drehen
        MoveL RelTool(pL_GP_KT,0,0,-50\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveL RelTool(pL_GP_KT,0,0,0\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibriergreifer ffnen
        r_tKalibrier_GR_AUF;
        !
        RETURN ;
    ENDPROC




    !***************************************************************************
    !*  Procedure  rL_zurueck_in_GP_KT()
    !*
    !*  YuMi legt das Kalibrierteil in der Greifposition ab
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_zurueck_in_GP_KT()
        !  
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,z20,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibrierteil um 90 drehen
        MoveJ RelTool(pL_GP_KT,0,0,-50\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveJ RelTool(pL_GP_KT,0,0,0\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibriergreifer ffnen
        r_tKalibrier_GR_AUF;
        !
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_HomePos_mit_Teil_aus_N()
    !*
    !*  YuMi greift das Kalibrierteil in Ablageposition und fhrt mit Teil
    !*  in die Home Position
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rL_HomePos_mit_Teil_aus_N()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveJ Offs(pL_GP_KT,0,0,50),vMedium,z20,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveL pL_GP_KT,vSlow,fine,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--Kalibriergreifer schliessen
        r_tKalibrier_GR_ZU;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveL Offs(pL_GP_KT,0,0,50),vfast,z20,tKalibrier_GR\WObj:=obFeeder_L;
        !
        !--in Home Position fahren
        MoveJ pL_HomePos,vfast,fine,tKalibrier_GR;
        !
        RETURN ;
    ENDPROC





ENDMODULE