MODULE L_Global


    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Positionen:
    !--------------
    !
    !--Home Position
    CONST robtarget pL_HomePos:=[[-177.88,255.23,187.85],[0.000207379,0.999959,0.00903483,0.00091053],[0,0,-1,4],[94.4487,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !
    !--Greifposition Zufhrung Rechts
    PERS robtarget pL_Pick_ZUF:=[[-46.897,-88.445,35.3],[3.96924E-05,0.00721807,-0.999974,9.07463E-05],[-1,0,0,4],[98.4466,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !
    !--Freifahrpunkt zur HomePos
    PERS robtarget pL_FFP_HomePos:=[[184.73,438.01,207.73],[0.0289479,0.714195,-0.699227,-0.0130426],[-1,0,-1,4],[-142.635,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !
    !--Bereitschaftsposition
    CONST robtarget pL_ALS:=[[0,-300,85],[4.08916E-05,0.00375918,-0.999993,4.58337E-07],[-1,0,-1,4],[-143.606,9E+09,9E+09,9E+09,9E+09,9E+09]];
    
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Werkzeugdaten:
    !----------------
    !
    !--Kalibriergreifer
    TASK PERS tooldata tKalibrier_GR:=[TRUE,[[0,0,134.7],[1,0,0,0]],[0.24,[8.2,12.5,48.1],[1,0,0,0],0.00018,0.0002,9E-05]];
    !    
    !--Greifer Porta Grundkrper
    TASK PERS tooldata t_10001_Grundkrper_GR:=[TRUE,[[0,0,134.7],[1,0,0,0]],[0.24,[8.2,12.5,48.1],[1,0,0,0],0.00018,0.0002,9E-05]];
    !
    !--Werkzeugdaten fr Greifer am Arm Links bezogen auf Drehkante beim Fgen
    TASK PERS tooldata tServoGR_L_Sw:=[TRUE,[[0,-18.6,140.3],[1,0,0,0]],[0.24,[8.2,12.5,48.1],[1,0,0,0],0.00018,0.0002,9E-05]];
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Werkobjekte:
    !---------------
    !
    !--Werkobjekt fr Feeder Links (Vision)
    TASK PERS wobjdata obFeeder_L:=[FALSE,TRUE,"",[[-62,430,111],[0.707128,6.99913E-05,2.97644E-05,0.707086]],[[0,0,0],[1,0,0,0]]];
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--eignene "Speeddata" Deklarationen:
    !------------------------------------
    !
    TASK PERS speeddata vSwing:=[10,30,500,500];
    TASK PERS speeddata vPos:=[100,500,500,500];
    TASK PERS speeddata vSlow:=[300,500,500,500];
    TASK PERS speeddata vSemiSlow:=[600,500,500,500];
    TASK PERS speeddata vMedium:=[1000,500,500,500];
    TASK PERS speeddata vFast:=[2500,500,500,500];
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Stationen:
    !------------
    !  ZUF_R  Zufhrung fr Arm Rechts
    !  ZUF_L  Zufhrung fr Arm Links
    !  FUS    Fgestation  (zusammenfgen der beiden Teile)
    !  ALS    Ablagestation

    !--Roboterpos Namen:
    !-------------------
    !  VP   Vorposition der Station
    !  GP   Greifposition in der Station
    !  EP   Einlegeposition in der Station
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------



    !***************************************************************************
    !*  Procedure  rL_Home
    !*
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  xx              xxx          xxx
    !***************************************************************************
    PROC rL_Home()
        !
        !-In Home Position fahren
        MoveJ pL_HomePos,vFast,z20,tKalibrier_GR;
        RETURN ;
    ENDPROC



    PROC r_tKalibrier_GR_ZU()
        VAR num nFK;
        !--> Kalibriergreifer schliessen mit 10 N Spannkraft
        Hand_GripInward\holdForce:=10;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDGRIPPOS THEN
            !wenn Greiffehler (unerwartete Greiferstellung)
            TPErase;
            TPWrite "Greif Fehler Links";
            TPWrite "Teilposition prfen/korrigieren";
            Hand_MoveTo 5;
            TPReadFK nFK,"Greifversuch wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
    ENDPROC



    PROC r_tKalibrier_GR_AUF()
        VAR num nFK;
        !--> Kalibriergreifer ffnen
        Hand_MoveTo 15;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDMOVEPOS THEN
            !wenn Greiffehler (Soll Greiferstellung kann nicht erreicht werden)
            TPErase;
            TPWrite "Greif Fehler Links";
            TPWrite "Greifer kann nicht in Sollpos fahren";
            TPWrite "Situation prfen/korrigieren";
            TPReadFK nFK,"Greifer ffnen wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
        RETURN ;
    ENDPROC



    PROC r_t_10001_Grundkrper_GR_ZU()
        VAR num nFK;
        !--> Kalibriergreifer schliessen mit 10 N Spannkraft
        Hand_GripInward\holdForce:=10;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDGRIPPOS THEN
            !wenn Greiffehler (unerwartete Greiferstellung)
            TPErase;
            TPWrite "Greif Fehler Links";
            TPWrite "Teilposition prfen/korrigieren";
            Hand_MoveTo 5;
            TPReadFK nFK,"Greifversuch wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
    ENDPROC



    PROC r_t_10001_Grundkrper_GR_AUF()
        VAR num nFK;
        !--> Kalibriergreifer ffnen
        Hand_MoveTo 15;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDMOVEPOS THEN
            !wenn Greiffehler (Soll Greiferstellung kann nicht erreicht werden)
            TPErase;
            TPWrite "Greif Fehler Links";
            TPWrite "Greifer kann nicht in Sollpos fahren";
            TPWrite "Situation prfen/korrigieren";
            TPReadFK nFK,"Greifer ffnen wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
        RETURN ;
    ENDPROC



    PROC r_Calibrate_GR()
        VAR bool bLeftHandCalibrated;
        !--Prfen ob Servogreifer kalibriert ist

        !bRightHandCalibrated:=g_IsCalibrated();
        bLeftHandCalibrated:=Hand_IsCalibrated();

        IF bLeftHandCalibrated=FALSE THEN
            !--Finger ganz schliessen und kalibirieren

            !g_Init\Calibrate;
            Hand_Initialize\Calibrate;
            !--
            !mit 20 mm/s und einer Haltekraft von 10 N initiiert.
            !g_Init\maxSpd:=20,\holdForce:=10;
            Hand_Initialize\maxSpd:=20,\holdForce:=10;


        ENDIF
        RETURN ;



    ENDPROC
ENDMODULE