MODULE L_VISION

    !--Arm Links

    ! DATA DECLARATIONS

    PERS num nL_XOffs:=-46.897;
    PERS num nL_YOffs:=-88.445;
    PERS num nL_Angle:=269.77;
    VAR string stReceived;
    !
    VAR socketdev ComSocket;
    VAR socketstatus SoStatus;

    PERS string stReceivedFrmCognex:="";
    !
    PERS wobjdata wFixture:=[FALSE,TRUE,"",[[0,0,0],[1,0,0,0]],[[-232.163,302.762,0],[0.713972,0,0,0.700174]]];

    !Variablen fr Kalibrierung
    VAR num nCalibPos:=0;
    VAR num nCalibWinkel:=0;
    VAR num nStatus;
    PERS num nXSTR_Pos;
    PERS num nYSTR_Pos;
    PERS num nCSTR_Pos;
    VAR string stAkt_Pos;
    VAR string stXPos;
    VAR string stYPos;
    VAR string stSocketbefehl;
    VAR string stEmpfang;
    VAR string stTask;
    VAR pos pPick_Teil;
    VAR pos psAkt_Pos;



    !Variablen fr Kamera Connection
    CONST string stIP_Adresse:="192.168.2.20";
    CONST string stUser:="admin";
    CONST string stPassword:="";

    !Variablen fr Ablagepositionen auf dem Flexfeeder
    !            CalibPos   [x,y,c] (x und y anpassen auf Feedergrsse und c immer 0)
    CONST pos pL_CalibPos1:=[80,-80,0];
    CONST pos pL_CalibPos2:=[-80,-80,0];
    CONST pos pL_CalibPos3:=[-80,80,0];
    CONST pos pL_CalibPos4:=[80,80,0];


    !***************************************************************************
    !*  Procedure  rL_Sendstring 
    !*  
    !*  Senden eines Strings an Socketverbindung
    !*  Achtung String ohne CR LF (\0D\0A) bergeben
    !*  stSendtring        = Befehl, fr Cognex
    !*  stRecedivedstring  = Statusrckmeldung und Daten von Cognex
    !*  stMeldungZeile1    = Text fr Ausgabezeile 1 auf Flexpanel
    !*  stMedlungZeile2    = Text fr Ausgabezeile 2 auf Flexpanel 
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************

    PROC rL_Sendstring(string st_Sendstring,string stMeldungZeile1,string stMeldungZeile2)

        SocketSend ComSocket\Str:=st_Sendstring+"\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF fL_CheckStatus(stReceived,"1")=FALSE THEN
            TPErase;
            TPWrite(stMeldungZeile1);
            TPWrite(stMeldungZeile2);
            Stop;
        ENDIF
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_Flex_Datei_laden
    !*  
    !*  Flexfeeder Programm laden 
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************

    PROC rL_Flex_Datei_laden(string stJobDatei)


        !Socketverbindung ffnen und anmelden an der Camera
        SoStatus:=SocketGetStatus(ComSocket);
        IF SoStatus<>SOCKET_CONNECTED THEN
            SocketClose ComSocket;
            rL_ConnectToInSight stIP_Adresse,stUser,stPassword;
        ENDIF

        !Cognex Offline schalten
        rL_Sendstring "SO0","Cognex Befehl SO0 wurde","nicht angenommen";

        WaitTime 1.0;

        !Job Datei laden (ohne Dateiendung und keine Punkte im Dateimanen verwenden
        rL_Sendstring "LF"+stJobDatei,"Cognex Befehl LF"+stJobDatei+" wurde","nicht angenommen";

        WaitTime 4.0;

        !Cognex Online schalten
        rL_Sendstring "SO1","Cognex Befehl SO1 wurde","nicht angenommen";

        WaitTime 4.0;


    ENDPROC


    !***************************************************************************
    !*  Procedure  rL_Flex_Start_Stream
    !*  
    !*  Flexfeeder Streamin Mode starten
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************

    PROC rL_Flex_Start_Stream()

        ! Feeder Start
        rL_Sendstring "SIT0120","Cognex Befehl SIT0120 wurde","nicht angenommen";


        ! Feeder Start
        rL_Sendstring "SM"+"\34"+"Start"+"\34"+"0","Cognex Befehl "+"SM"+"\34"+"Start"+"\34"+"0"+" wurde","nicht angenommen";


    ENDPROC




    !***************************************************************************
    !*  Procedure  rL_Flex_Stop 
    !*  
    !*  Flexfeeder Stop
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************

    PROC rL_Flex_Stop()

        ! Feeder Stop
        rL_Sendstring "SIT0121","Cognex Befehl SIT0121 wurde","nicht angenommen";


    ENDPROC

    !***************************************************************************
    !*  Procedure  rL_Flex_Entleeren
    !*  
    !*  Flexfeeder entleeren
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************

    PROC rL_Flex_Start_Entleeren()

        ! Feeder Start
        rL_Sendstring "SIT0121","Cognex Befehl SIT0121 wurde","nicht angenommen";

        Reset do_Pick_links;


    ENDPROC


    !***************************************************************************
    !*  Procedure  rL_GetVisionData
    !*  
    !*  Daten von Kamera lesen
    !*  ohne Streaminmode
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  11.04.2017        000        BLA
    !***************************************************************************

    PROC rL_GetVisionData()
        VAR string XData:="";
        VAR string YData:="";
        VAR string AngleData:="";
        VAR string stPickPosData;
        VAR num NumCharacters:=9;
        VAR bool bOK;
        VAR num nNoPart;
        VAR num nString_Laenge;

        nL_XOffs:=0;
        nL_YOffs:=0;
        nL_Angle:=0;


        !Socketverbindung ffnen
        SoStatus:=SocketGetStatus(ComSocket);
        IF SoStatus<>SOCKET_CONNECTED THEN
            SocketClose ComSocket;
            rL_ConnectToInSight "192.18.2.20","Admin","";
        ENDIF

        ! Feeder Start
        SocketSend ComSocket\Str:="SIT0120\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF fL_CheckStatus(stReceived,"1")=FALSE THEN
            Stop;
        ENDIF

        !SocketSend ComSocket\Str:="SM\34Start\340";
        !SocketReceive ComSocket\Str:=stReceived;

        !Robotertask aus Zelle L0 auslesen



        nString_Laenge:=0;

        While nString_Laenge<20 DO

            SocketSend ComSocket\Str:="GVR002\0D\0A";
            SocketReceive ComSocket\Str:=stReceived;
            IF fL_CheckStatus(stReceived,"1")=FALSE THEN
                Stop;
            ENDIF

            nString_Laenge:=StrLen(stReceived);

        ENDWHILE


        ! Parse the data string

        stPickPosData:=StrPart(stReceived,4,34);

        nXSTR_Pos:=StrFind(stPickPosData,1,"X");
        nYSTR_Pos:=StrFind(stPickPosData,nXSTR_Pos,"Y");
        nCSTR_Pos:=StrFind(StPickPosData,nYSTR_Pos,"C");
        !nSemi_Pos:=StrFind(StPickPosData,nCSTR_Pos,";");
        XDATA:=StrPart(stPickPosData,nXSTR_Pos+1,8);
        YDATA:=StrPart(stPickPosData,nYSTR_Pos+1,8);
        AngleDATA:=StrPart(stPickPosData,nCSTR_Pos+1,8);
        !XData:=StrPart(stPickPosData,0,NumCharacters);
        !YData:=StrPart(stPickPosData,NumCharacters,NumCharacters);
        !AngleData:=StrPart(stPickPosData,2*NumCharacters,NumCharacters);

        !Convert String Data To Numerical Data
        bOK:=StrToVal(XData,nL_XOffs);
        bOK:=StrToVal(YData,nL_YOffs);
        bOK:=StrToVal(AngleData,nL_Angle);

    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_Akt_Pos
    !*  
    !*  aktuelle X und Y Position aufbereiten fr bergabe zu Cognex
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  10.04.2017        000        BLA
    !***************************************************************************
    PROC rL_Akt_Pos()

        VAR num nCommaPos1;
        VAR num nCommaPos2;

        !aktuelle Position abrufen
        !pAkt_Pos:=CPos(\Tool:=tKalibrier_GR\WObj:=obFeeder_R);

        psAkt_Pos:=pL_GP_KT.trans;

        !Umwandeln aktuelle Position in String
        stAkt_Pos:=ValToStr(psAkt_Pos);

        !erstes komma im String suchen
        nCommaPos1:=StrFind(StAkt_Pos,1,",");

        !zweites Komma in String suchen
        nCommaPos2:=StrFind(StAkt_Pos,nCommaPos1+1,",");

        !X-Position aus String ausschneiden (alles zwischen Anfang String bis erstem Komma)
        stXPos:=StrPart(stAkt_Pos,2,nCommaPos1-1);

        !Y-position aus String ausschneiden (alles zwischen erstem Komma und zweitem Komma)
        stYPos:=StrPart(stAkt_Pos,nCommaPos1+1,nCommaPos2-nCommaPos1-1);
        RETURN ;
    ENDPROC





    PROC rL_CalcOframe()
        !Reset object frame
        wFixture.oframe:=[[0,0,0],[1,0,0,0]];
        ! assigne measurement data
        wFixture.oframe.trans.x:=nL_XOffs;
        wFixture.oframe.trans.y:=nL_YOffs;
        wFixture.oframe.rot:=OrientZYX(nL_Angle,0,0);
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_Vision_Calib
    !*
    !*  Kalibrierablauf fr Flexfeeder
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        001        BLA
    !***************************************************************************
    PROC rL_Vision_Calib()
        VAR num nClaibnummer;
        VAR num nDrehung;
        VAR num nCalibPos;
        VAR string stPosAufruf;
        VAR BOOL bFeeder_Status;
        VAR BOOL bParameter_Send;
        VAR BOOL bFeeder_Init;


        !Greifer kalibrieren
        r_Calibrate_GR;
        r_tKalibrier_GR_AUF;


        !Homeposition anfahren
        rL_Home;

        !Datei laden in Cognex
        rL_Flex_Datei_laden "Calibration32-P";

        !Warten bis Anyfeeder in Grundstellung ist 
        nStatus:=0;
        WHILE nStatus<>+1 DO
            rL_Sendstring "GVM023","Cognex Befehl GVM023 wurde","nicht angenommen";
            rL_Empfang stReceived;
        ENDWHILE

        !Verschiebung auf Null
        pL_GP_KT.trans.x:=0;
        pL_GP_KT.trans.y:=0;


        !Wiederholungen bis alle 4 Punkte geteacht sind.
        FOR nCalibNummer FROM 0 TO 3 DO

            !Variable fr Punktbefehl 
            stPosAufruf:=NumToStr(nCalibNummer,0);

            !Kalibrierpunkt 1 aufrufen
            rL_Sendstring "SIM018"+stPosAufruf,"Cognex Befehl SIM018"+stPosAufruf+"wurde","nicht angenommen";


            !Kalbrierteil aufnehmen
            pL_GP_KT.trans.x:=0;
            pL_GP_KT.trans.y:=0;
            rL_GP_KT;


            !Kalibrieablauf starten 
            rL_Sendstring "SE1"," Cognex Befehl SE1 wurde "," nicht angenommen ";


            Waittime 1.0;

            stEmpfang:="";

            !Schleife solange abarbeiten bis NoPart
            WHILE stEmpfang<>"NoPart" DO

                !Robotertask aus Zelle L0 auslesen
                rL_Sendstring "GVL000","Cognex Befehl GVL000"+stPosAufruf+"wurde","nicht angenommen";

                !Rckmeldestring bereinigen und Befehl isolieren
                rL_Empfang stReceived;

                ! Auswerten der Rckmeldung
                ! Rckmeldung ==> Error             ==> Ablauffehler Kalibrierung muss neu gestartet werden
                ! Rckmeldung ==> NoPart            ==> kein Teil erkannt auf Flexfeeder
                ! Rckmeldung ==> CalibZur          ==> Kalibrierteil vom Flexfeeder entfernen
                ! Rckmeldung ==> CalibX,CXXX.XXX   ==> Kalibrierposition i = 0, Winkel C = 000.000 


                TEST stEmpfang

                CASE "NoPart":

                    !Verschiebung lschen und in Grundposition fahren
                    pL_GP_KT.trans.x:=0;
                    pL_GP_KT.trans.y:=0;
                    rL_zurueck_in_GP_KT;


                CASE "CalibZur":
                    !Quittieren, dass Befehl verstanden ist setzen
                    rL_Sendstring "SIH0001","Cognex Befehl SIH001 wurde","nicht angenommen";

                    ! Teil von letzter Position aufnehmen und aus dem Kamerabereich fahren
                    rL_HomePos_mit_Teil_aus_N;

                    !Quittieren, dass Befehl ausgefhrt ist
                    rL_Sendstring "SIH0000","Cognex Befehl SIH000 wurde","nicht angenommen";


                CASE "Calib1;C000.000",
                    "Calib1;C090.000",
                    "Calib1;C180.000",
                    "Calib1;C270.000",
                    "Calib2;C000.000",
                    "Calib2;C090.000",
                    "Calib2;C180.000",
                    "Calib2;C270.000",
                    "Calib3;C000.000",
                    "Calib3;C090.000",
                    "Calib3;C180.000",
                    "Calib3;C270.000",
                    "Calib4;C000.000",
                    "Calib4;C090.000",
                    "Calib4;C180.000",
                    "Calib4;C270.000":
                    ! Position und Winkel der Verschiebung anfahren und Daten bbergeben
                    rL_CalibX_WinkelX stEmpfang;
                DEFAULT:
                    ! Falls gefunden wurde, Fehler ausgeben
                    TPErase;
                    TPWrite "Kaliberiung neu starten";
                    TPWrite stEmpfang+", wird nicht erkannt als Funktion";
                    Stop;
                ENDTEST



            ENDWHILE
        ENDFOR



        ! Speichern der Calib-Daten in der Cognex        
        rL_Sendstring "SE2","Cognex Befehl SE2 wurde","nicht angenommen";

        ! Roboter in Homeposition
        rL_Home;

        ! Grundstellung
        rL_Nullpos;

        !Kamera offline
        rL_Sendstring "SO0","Cognex Befehl SO0 wurde","nicht angenommen";

        Waittime 1;

        !Job speichern
        rL_Sendstring "TFCalibration32-P.job","Cognex Befehl TFCalibration32-P.job wurde","nicht angenommen";

        Waittime 1;

        !Kamera online
        rL_Sendstring "SO1","Cognex Befehl SO0 wurde","nicht angenommen";
        Waittime 1;
        RETURN ;

    ENDPROC

    
    
    !***************************************************************************
    !*  Procedure  rL_Empfang
    !*
    !*  String ohne Steuerzeichen aufbreiten
    !*  Status CR und LF am Anfang und Ende entfernen
    !*  Unterscheiden zwischen Status von Feeder (1.000,0.000,-1.000) und 
    !*  Befehl von Feeder (NoPart.CalibZur,CalibX;CXXX.XXX)
    !*  Date:          Version:    Programmer:    Reason:
    !*  12.04.2017        000        BLA
    !***************************************************************************
    PROC rL_Empfang(string stDaten)

        VAR num nDaten_Laenge:=0;
        VAR bool bPosOK;
        VAR bool bWinkelOK;
        VAR bool bZahl;

        stEmpfang:="";
        nDaten_Laenge:=STRLEN(stReceived);
        IF nDaten_Laenge<8 THEN
            TPErase;
            TPWrite "Vision Kalibrierung Ablauf neu starten";
            Stop;
        ENDIF

        stEmpfang:=StrPart(stReceived,4,nDaten_Laenge-5);

        bZahl:=StrToVAL(stEmpfang,nStatus);
        IF bZahl=FALSE THEN
            IF stEmpfang<>"CalibZur" AND stEmpfang<>"NoPart"
            THEN
                bPosOK:=StrtoVal(Strpart(stEmpfang,6,1),nCalibPos);
                bWinkelOK:=StrtoVal(Strpart(stEmpfang,9,7),nCalibWinkel);
                nStatus:=0;
            ENDIF
        ELSE
            nCalibPos:=0;
            nCalibWinkel:=0;
        ENDIF
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rL_CalibX_WinkelX
    !*
    !*  Teil auf Kalibrierposition legen Daten bergeben und wegfahren
    !*
    !*  
    !*  Date:          Version:    Programmer:    Reason:
    !*  12.04.2017        000        BLA
    !***************************************************************************
    PROC rL_CalibX_WinkelX(string stCalibDaten)


        !Quittieren Befehl verstanden

        rL_Sendstring "SIH0001","Cognex Befehl SIH0001 wurde","nicht angenommen";


        !Verschiebung                  

        Test nCalibPos
        CASE 1:

            pL_GP_KT.trans.x:=pL_CalibPos1.x;
            pL_GP_KT.trans.y:=pL_CalibPos1.y;
        CASE 2:
            pL_GP_KT.trans.x:=pL_CalibPos2.x;
            pL_GP_KT.trans.y:=pL_CalibPos2.y;
        CASE 3:
            pL_GP_KT.trans.x:=pL_CalibPos3.x;
            pL_GP_KT.trans.y:=pL_CalibPos3.y;

        CASE 4:
            pL_GP_KT.trans.x:=pL_CalibPos4.x;
            pL_GP_KT.trans.y:=pL_CalibPos4.y;

        DEFAULT:
            TPErase;
            TPWrite "Error Position";
            TPWrite "Kalibrierung neu starten";
            Stop;


        ENDTEST

        !Kalibrierposition mit den Verschiebungen anfahren
        !Bei Winkel 0 andere Prozedur als bei 90,180,270
        IF nCalibWinkel=0
        THEN
            rL_AP_N;
        ELSE
            rL_AP_N_90;
        ENDIF

        !angefahrene Positionsdaten an Camera bermitteln
        rL_Pos_Daten_an_Feeder;

        ! Roboter aus dem Bild fahren
        rL_HomePos_ohne_Teil_aus_N;

        !Quittieren Befehl ausgefhrt

        rL_Sendstring "SIH0000","Cognex Befehl SIH0000 wurde","nicht angenommen";

    ENDPROC


    
    !***************************************************************************
    !*  Procedure  rL_Pos_Daten_an_Feeder
    !*
    !*  Positiondaten in Kamera schreiben
    !*
    !*  
    !*  Date:          Version:    Programmer:    Reason:
    !*  12.04.2017        000        BLA
    !***************************************************************************
    PROC rL_Pos_Daten_an_Feeder()

        !Aktuelle Armposition aus Steuerung auslesen und bergeben
        rL_Akt_Pos;

        ! X Koordinate der Ablegeposition an Kamera senden


        stSocketbefehl:="SFP000"+stXPos+"\0D\0A";
        SocketSend ComSocket\Str:=stSocketbefehl;
        SocketReceive ComSocket\Str:=stReceived;
        IF fL_CheckStatus(stReceived,"1")=FALSE THEN
            Stop;
        ENDIF


        ! Y Koordinate der Ablegeposition an Kamera senden
        stSocketbefehl:="SFQ000"+stYPos+"\0D\0A";
        SocketSend ComSocket\Str:=stSocketbefehl;
        SocketReceive ComSocket\Str:=stReceived;
        IF fL_CheckStatus(stReceived,"1")=FALSE THEN
            Stop;
        ENDIF

        RETURN ;
    ENDPROC


    
    !***************************************************************************
    !*  rL_ConnectToInSight
    !*  
    !*  Verbindung zur Kamera herstellen
    !*  Stanbdard User = "Admin"   Passwort = ""
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************
    PROC rL_ConnectToInSight(string stIP,string stUser,string stPassword)
        !Create socket
        SocketCreate ComSocket;
        !Connect to cognex insight
        SocketConnect ComSocket,stIP,23;
        !
        SocketReceive ComSocket\Str:=stReceived;
        !check, that last 6 characters are "User: "
        stReceived:=fL_StrRightPart(stReceived,6);
        IF stReceived<>"User: " THEN
            TPErase;
            TPWrite "Vision Login Error (User Prompt)";
            Stop;
        ENDIF

        ! Send the Username
        SocketSend ComSocket\Str:=stUser+"\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF stReceived<>"Password: " THEN
            TPErase;
            TPWrite "Vision Login Error (Password Prompt)";
            Stop;
        ENDIF

        ! Send Password
        SocketSend ComSocket\Str:=stPassword+"\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF stReceived<>"User Logged In\0D\0A" THEN
            TPErase;
            TPWrite "Vision Login Error (Final Login)";
            Stop;
        ENDIF
    ENDPROC

    FUNC string fL_strRightPart(
  string Text,
  num Length)

        VAR num Textlength;

        Textlength:=StrLen(Text);
        IF Length>Textlength THEN
            TPWrite "Given length is greater than whole text length";
            Stop;
        ENDIF
        RETURN StrPart(Text,Textlength-Length+1,Length);
    ENDFUNC




    !***************************************************************************
    !*  Procedure  fL_Checkstatus 
    !*  
    !*  berprfung ob Command an Kamera angenommen wurde
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  05.05.2017        000        BLA
    !***************************************************************************
    FUNC bool fL_CheckStatus(
  string Text,
  string CompareText)

        VAR num Textlength;

        Textlength:=StrLen(CompareText);
        IF StrPart(Text,1,Textlength)<>CompareText THEN
            TPErase;
            TPWrite "Vision Error";
            RETURN FALSE;
        ENDIF
        Waittime 0.2;
        RETURN TRUE;
    ENDFUNC
ENDMODULE
