MODULE R_Feeder_Teach

    !
    !--Freifahrposition
    CONST robtarget pFFP:=[[14.50,-188.90,128.98],[0.0455603,-0.895106,-0.125557,-0.425376],[-1,-1,0,4],[-95.852,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !
    !--Greifposition Kalibrierteil
    PERS robtarget pR_GP_KT:=[[0,0,10],[0.000483821,0.786015,-0.618207,4.40494E-05],[0,0,0,4],[-136.951,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !



    !--Stationen:
    !------------
    !  FFP    Freifahrposition
    !  GP_KT  Greifposition Kalibrierteil
    !  AP_N1  Ablageposition Nest 1
    !  AP_N2  Ablageposition Nest 2
    !  AP_N3  Ablageposition Nest 3
    !  AP_N4  Ablageposition Nest 4

    !--Roboterpos Namen:
    !-------------------
    !


    !***************************************************************************
    !*  Procedure  rR_InitBeforeHome
    !*
    !*
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_InitBeforeHome()
        r_Calibrate_GR;
        rR_tKalibrier_GR_AUF;

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_InitAfterHome
    !*
    !*
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_InitAfterHome()

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_GP_KT
    !*
    !*  In Greifposition Kalibrierteil fahren und Kalibrierteil greifen
    !*  50 mm oberhalb Greifposition Kalibrierteil halten
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_GP_KT()
        !
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        WaitTime 1;
        !
        !--Greifposition Kalibrierteil (fine Zone verwenden)
        MoveJ pR_GP_KT,vSlow,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibriergreifer schliessen
        rR_tKalibrier_GR_ZU;
        !
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_AP_N()
    !*
    !*  Kalibrierteil in Ablageposition Nest ablegen
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_AP_N()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50 mm vertikal ber Ablageposition Nest 1
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        WaitTime 1;
        !
        !--Greifposition (fine Zone verwenden)
        MoveL pR_GP_KT,vPos,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibriergreifer ffnen
        rR_tKalibrier_GR_AUF;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_HomePos_ohne_Teil_aus_N()
    !*
    !*  YuMi fhrt aus Ablageposition in Home Position
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_HomePos_ohne_Teil_aus_N()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveL Offs(pR_GP_KT,0,0,50),vfast,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        WaitTime 1;
        !
        !--in Home Position fahren
        MoveJ pR_HomePos,vfast,fine,tKalibrier_GR;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_AP_N_90()
    !*
    !*  YuMi fhrt in Ablageposition Nest, greift das Kalibrierteil,
    !*  dreht es um 90 und macht den Greifer auf
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_AP_N_90()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveL pR_GP_KT,vSlow,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibriergreifer schliessen
        rR_tKalibrier_GR_ZU;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveL Offs(pR_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibrierteil um 90 drehen
        MoveL RelTool(pR_GP_KT,0,0,-50\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveL RelTool(pR_GP_KT,0,0,0\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibriergreifer ffnen
        rR_tKalibrier_GR_AUF;
        !
        RETURN ;
    ENDPROC




    !***************************************************************************
    !*  Procedure  rR_zurueck_in_GP_KT()
    !*
    !*  YuMi legt das Kalibrierteil in der Greifposition ab
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_zurueck_in_GP_KT()
        !  
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,z20,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibrierteil um 90 drehen
        MoveJ RelTool(pR_GP_KT,0,0,-50\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveJ RelTool(pR_GP_KT,0,0,0\Rz:=90),vfast,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibriergreifer ffnen
        rR_tKalibrier_GR_AUF;
        !
        !--50mm vertikal ber Greifposition Kalibrierteil
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_HomePos_mit_Teil_aus_N()
    !*
    !*  YuMi greift das Kalibrierteil in Ablageposition und fhrt mit Teil
    !*  in die Home Position
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  03.04.2017        000        FSC/HES
    !***************************************************************************
    PROC rR_HomePos_mit_Teil_aus_N()
        !
        SingArea\Wrist;
        !
        ConfL\On;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveJ Offs(pR_GP_KT,0,0,50),vMedium,z20,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Ablageposition (fine Zone verwenden)
        MoveL pR_GP_KT,vSlow,fine,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--Kalibriergreifer schliessen
        rR_tKalibrier_GR_ZU;
        !
        !--50mm vertikal ber Ablageposition Nest 1 fahren
        MoveL Offs(pR_GP_KT,0,0,50),vfast,z20,tKalibrier_GR\WObj:=obFeeder_R;
        !
        !--in Home Position fahren
        MoveJ pR_HomePos,vfast,fine,tKalibrier_GR;
        !
        RETURN ;
    ENDPROC





ENDMODULE