MODULE R_Global


    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Positionen:
    !--------------
    !
    !--Home Position
    CONST robtarget pR_HomePos:=[[-134.19,-230.63,214.59],[7.54306E-06,-0.999973,-0.00730499,-5.99667E-06],[0,0,-1,4],[-137.97,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !
    !--Greifposition Zufhrung Rechts
    PERS robtarget pR_Pick_ZUF:=[[-56.187,33.524,29],[0.00042349,-0.00725503,-0.999974,3.262E-05],[0,1,0,4],[-138.489,9E+09,9E+09,9E+09,9E+09,9E+09]];
    !
    !--Bereitschaftsposition
    CONST robtarget pR_ALS:=[[0,-310,110],[6.66481E-05,-0.0117033,-0.999931,-0.000855295],[-1,-1,2,4],[123.895,9E+09,9E+09,9E+09,9E+09,9E+09]];
    
    !
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Werkzeugdaten:
    !----------------
    !
    !--Kalibriergreifer
    TASK PERS tooldata tKalibrier_GR:=[TRUE,[[0,0,134.7],[1,0,0,0]],[0.24,[8.2,12.5,48.1],[1,0,0,0],0.00018,0.0002,9E-05]];
    !    
    !--Greifer Porta Feder
    TASK PERS tooldata t_10001_Feder_GR:=[TRUE,[[0,0,134.7],[1,0,0,0]],[0.24,[8.2,12.5,48.1],[1,0,0,0],0.00018,0.0002,9E-05]];
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Werkobjekte:
    !---------------
    !
    !--Werkobjekt fr Feeder Rechts (Vision)
    TASK PERS wobjdata obFeeder_R:=[FALSE,TRUE,"",[[-62,-430,111],[0.706658,-0.000543996,-0.000636132,0.707555]],[[0,0,0],[1,0,0,0]]];
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--eignene "Speeddata" Deklarationen:
    !------------------------------------
    !
    TASK PERS speeddata vSwing:=[10,30,500,500];
    TASK PERS speeddata vPos:=[100,500,500,500];
    TASK PERS speeddata vSlow:=[300,500,500,500];
    TASK PERS speeddata vSemiSlow:=[600,500,500,500];
    TASK PERS speeddata vMedium:=[1000,500,500,500];
    TASK PERS speeddata vFast:=[2500,500,500,500];
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------
    !
    !--Stationen:
    !------------
    !  ZUF_R  Zufhrung fr Arm Rechts
    !  ZUF_L  Zufhrung fr Arm Links
    !  FUS    Fgestation  (zusammenfgen der beiden Teile)
    !  ALS    Ablagestation

    !--Roboterpos Namen:
    !-------------------
    !  VP   Vorposition der Station
    !  GP   Greifposition in der Station
    !  EP   Einlegeposition in der Station
    !
    !-----------------------------------------------------------------------------------------------------------------------------------------------



    !***************************************************************************
    !*  Procedure  rR_Home
    !*
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  xx              xxx          xxx
    !***************************************************************************
    PROC rR_Home()
        !
        !-In Home Position fahren
        MoveJ pR_HomePos,vFast,z20,tKalibrier_GR;
        RETURN ;
    ENDPROC

    

PROC rR_tKalibrier_GR_ZU()
        VAR num nFK;
        !--> Kalibriergreifer schliessen mit 10 N Spannkraft
        Hand_GripInward\holdForce:=10;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDGRIPPOS THEN
            !wenn Greiffehler (unerwartete Greiferstellung)
            TPErase;
            TPWrite "Greif Fehler";
            TPWrite "Teilposition prfen/korrigieren";
            Hand_MoveTo 5;
            TPReadFK nFK,"Greifversuch wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
    ENDPROC



    PROC rR_tKalibrier_GR_AUF()
        VAR num nFK;
        !--> Kalibriergreifer ffnen
        Hand_MoveTo 15;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDMOVEPOS THEN
            !wenn Greiffehler (Soll Greiferstellung kann nicht erreicht werden)
            TPErase;
            TPWrite "Greif Fehler";
            TPWrite "Greifer kann nicht in Sollpos fahren";
            TPWrite "Situation prfen/korrigieren";
            TPReadFK nFK,"Greifer ffnen wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
        RETURN ;     
    ENDPROC

    
PROC r_t_10001_Feder_GR_ZU()
        VAR num nFK;
        !--> Kalibriergreifer schliessen mit 8 N Spannkraft
        Hand_GripInward\holdForce:=8;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDGRIPPOS THEN
            !wenn Greiffehler (unerwartete Greiferstellung)
            TPErase;
            TPWrite "Greif Fehler";
            TPWrite "Teilposition prfen/korrigieren";
            Hand_MoveTo 5;
            TPReadFK nFK,"Greifversuch wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
    ENDPROC



    PROC r_t_10001_Feder_GR_AUF()
        VAR num nFK;
        !--> Kalibriergreifer ffnen
        Hand_MoveTo 13;
    ERROR
        IF ERRNO=ERR_HAND_FAILEDMOVEPOS THEN
            !wenn Greiffehler (Soll Greiferstellung kann nicht erreicht werden)
            TPErase;
            TPWrite "Greif Fehler";
            TPWrite "Greifer kann nicht in Sollpos fahren";
            TPWrite "Situation prfen/korrigieren";
            TPReadFK nFK,"Greifer ffnen wird wiederholt","","","","","WEITER";
            TPErase;
            RETRY;
        ENDIF
        RETURN ;     
    ENDPROC
        
    
    
PROC r_Calibrate_GR()
        VAR bool bRightHandCalibrated;
        !--Prfen ob Servogreifer kalibriert ist

        !bRightHandCalibrated:=g_IsCalibrated();
        bRightHandCalibrated:=Hand_IsCalibrated();

        IF bRightHandCalibrated=FALSE THEN
            !--Finger ganz schliessen und kalibirieren

            !g_Init\Calibrate;
            Hand_Initialize\Calibrate;
            !--
            !mit 20 mm/s und einer Haltekraft von 10 N initiiert.
            !g_Init\maxSpd:=20,\holdForce:=10;
            Hand_Initialize\maxSpd:=20,\holdForce:=10;


        ENDIF
        RETURN ;
        
        
        
    ENDPROC
ENDMODULE