MODULE R_Test_Feeder_Porta_Feder


    PERS num nSollZyklen_Porta_Feder:=20;



    !--Stationen:
    !------------
    !  ZUF_R  Zufhrung fr Arm Rechts
    !  ZUF_L  Zufhrung fr Arm Links
    !  FUS1   Fgestation1  (zusammenfgen der beiden Teile)
    !  ALS1   Ablagestation1
    !  HOP    Homeposition

    !--Roboterpos Namen:
    !-------------------
    !  VP   Vorposition der Station
    !  GP   Greifposition in der Station
    !  EP   Einlegeposition in der Station



    !***************************************************************************
    !*  Procedure  main                     
    !*                                                        
    !*    
    !*  
    !*                                                        
    !*  Date:          Version:    Programmer:    Reason:     
    !*  26.04.2017        001        FSC/HAS                
    !*************************************************************************** 
    PROC main()

        rR_InitBeforeHome_Porta_Feder;

        rR_Home;

        FOR i FROM 1 TO nSollZyklen_Porta_Feder DO
            rR_Zyklus_Porta_Feder;
            !ENDWHILE
        ENDFOR

        !Signal an Feeder Stopp
        SET do_Pick_rechts;

        rR_Nullpos;

        Stop;

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_InitBeforeHome_Porta_Feder()
    !*
    !*  InitBeforeHome
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  26.04.2017        001        FSC/HAS
    !***************************************************************************
    PROC rR_InitBeforeHome_Porta_Feder()

        !Socketverbindung ffnen
        SoStatus:=SocketGetStatus(ComSocket);
        IF SoStatus<>SOCKET_CONNECTED THEN
            SocketClose ComSocket;
            rR_ConnectToInSight stIP_Adresse,stUser,stPassword;
        ENDIF

        !Cognex Offline schalten
        SocketSend ComSocket\Str:="SO0\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF  fR_CheckStatus(stReceived,"1")=FALSE THEN
            Stop;
        ENDIF

        WaitTime 1.0;

        !Kalibrierjob laden
        SocketSend ComSocket\Str:="LF057_0146_001\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF fR_CheckStatus(stReceived,"1")=FALSE THEN
            Stop;
        ENDIF

        WaitTime 1.0;

        !Cognex Online schalten
        SocketSend ComSocket\Str:="SO1\0D\0A";
        SocketReceive ComSocket\Str:=stReceived;
        IF fR_CheckStatus(stReceived,"1")=FALSE THEN
            Stop;
        ENDIF

        WaitTime 4.0;

        !Signal an Feeder Go
        RESET do_Pick_rechts;

        r_Calibrate_GR;

        r_t_10001_Feder_GR_AUF;

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_Zyklus_Porta_Feder()
    !*
    !*  Teil aus Zufhrung Rechts greifen
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  26.04.2017        001        FSC/HAS
    !***************************************************************************
    PROC rR_Zyklus_Porta_Feder()

        !Koordinaten von Vision an Yumi
        rR_GetVisionData;
        pR_Pick_ZUF.trans.x:=nR_XOffs;
        pR_Pick_ZUF.trans.y:=nR_YOffs;

        !Signal an Feeder Stopp
        SET do_Pick_rechts;

        rR_TeilAusZUF_R;

        rR_TeilinALS;

        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_TeilAusZUF_R()
    !*
    !*  Teil aus Zufhrung Rechts greifen
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  26.04.2017        001        FSC/HAS
    !***************************************************************************
    PROC rR_TeilAusZUF_R()
        !
        SingArea\Wrist;
        !
        ConfL\On;

        !MoveL pPick_Porta_Feder, vFast, z50, tPorta_Feder_GR\WObj:=obFeeder_R;

        MoveL Offs(pR_Pick_ZUF,0,0,50),vMedium,z20,t_10001_Feder_GR\WObj:=obFeeder_R;
        !
        WaitTime 1.0;
        !
        MoveJ RelTool(pR_Pick_ZUF,0,0,-50\Rz:=-nR_Angle),vfast,fine,t_10001_Feder_GR\WObj:=obFeeder_R;
        !
        !--Greifposition
        MoveJ RelTool(pR_Pick_ZUF,0,0,0\Rz:=-nR_Angle),vfast,fine,t_10001_Feder_GR\WObj:=obFeeder_R;
        !
        r_t_10001_Feder_GR_ZU;
        !
        !--50mm vertikal ber Greifposition
        MoveJ RelTool(pR_Pick_ZUF,0,0,-50\Rz:=-nR_Angle),vfast,fine,t_10001_Feder_GR\WObj:=obFeeder_R;
        !
        SingArea\off;
        !
        RETURN ;
    ENDPROC



    !***************************************************************************
    !*  Procedure  rR_TeilinALS()
    !*
    !*  Teil in Ablagestation einlegen
    !*
    !*
    !*  Date:          Version:    Programmer:    Reason:
    !*  26.04.2017        001        FSC/HAS
    !***************************************************************************
    PROC rR_TeilinALS()

        SingArea\Wrist;

        ConfL\On;

        MoveL pR_ALS,vFast,fine,t_10001_Feder_GR\WObj:=obFeeder_R;

        ConfL\Off;
        
        MoveJ Offs(pR_ALS,0,-250,-100),vFast,z20,t_10001_Feder_GR\WObj:=obFeeder_R;

        !Signal an Feeder Go
        RESET do_Pick_rechts;

        WaitTime 2.0;

        r_t_10001_Feder_GR_AUF;

        MoveL pR_ALS,vFast,fine,t_10001_Feder_GR\WObj:=obFeeder_R;

        SingArea\off;

        RETURN ;
    ENDPROC





ENDMODULE